
%macro BRAINFUCKINIT 0-1 30000  ;; Initializes BF array area with %1 bytes default =30000 (Return value in eax)
	%ifdef NAGOA
		%undef call
	%endif
	%push BFINIT
	extern GlobalAlloc
	import GlobalAlloc kernel32.dll
	extern WriteConsoleA
	import WriteConsoleA kernel32.dll
	extern GetStdHandle
	import GetStdHandle kernel32.dll
	extern ReadConsoleA
	import ReadConsoleA kernel32.dll
	extern GetConsoleMode
	import GetConsoleMode kernel32.dll
	extern SetConsoleMode
	import SetConsoleMode kernel32.dll
	push dword %1
	push dword GMEM_FIXED | GMEM_ZEROINIT
	call [GlobalAlloc]
	%ifdef NAGOA
		%define call call_
	%endif
%endmacro

%macro BRAINFUCK 1
	%ifdef NAGOA
		%undef call
        %endif
        %ifnctx BFINIT
        	%fatal "Expected BRAINFUCKINIT before BRAINFUCK ."
        %endif
	%strlen charcnt %1
	%assign i 1
	%rep charcnt
		%substr currchar %1 i

		%if currchar='<'
		   dec eax
		%elif currchar='>'
		   inc eax
		%elif currchar='+'
		   mov bl,byte [eax]
		   inc bl
		   mov byte[eax],bl
		%elif currchar='-'
		   mov bl,byte [eax]
		   dec bl
		   mov byte[eax],bl
		%elif currchar='.'
		   push eax
		   push dword 4
		   push dword GMEM_FIXED | GMEM_ZEROINIT
		   call [GlobalAlloc]
		   mov ebx,eax
		   push ebx
		   push dword STD_OUTPUT_HANDLE
		   call [GetStdHandle]
		   mov edx,eax
		   pop ebx
		   pop eax
		   push eax
		   push dword NULL
		   push dword ebx
		   push dword 1
		   push dword eax
		   push dword edx
		   call [WriteConsoleA]
		   pop eax
		   

		%elif currchar=','

		   push eax
		   
		   push dword 4
		   push dword GMEM_FIXED | GMEM_ZEROINIT
		   call [GlobalAlloc]
		   mov ebx,eax
		   mov edi,ebx
		   push ebx
		   
		   push dword STD_INPUT_HANDLE
		   call [GetStdHandle]
		   mov edx,eax
		   		   
		   pop ebx
		   push edx
		   push ebx
		   push eax
		   call [GetConsoleMode]
		   and byte [ebx], 0xFF ^ (ENABLE_LINE_INPUT | ENABLE_ECHO_INPUT)
		   pop edx
		   push edx
		   push dword [ebx]
		   push dword edx
		   call [SetConsoleMode]
		   pop edx
		   
		   pop eax
		   push eax
		   push dword NULL
		   push dword ebx ; push dword edi
		   push dword 1
		   push dword eax
		   push dword edx
		   call [ReadConsoleA]
		   pop eax
		;;;;;;;;;;;;;;;;;;;;;;
		;;;; echo the character typed to the screen.
		   push eax
		   push dword 4
		   push dword GMEM_FIXED | GMEM_ZEROINIT
		   call [GlobalAlloc]
		   mov ebx,eax
		   push ebx
		   push dword STD_OUTPUT_HANDLE
		   call [GetStdHandle]
		   mov edx,eax
		   pop ebx
		   pop eax
		   push eax
		   push dword NULL
		   push dword ebx
		   push dword 1
		   push dword eax
		   push dword edx
		   call [WriteConsoleA]
		   pop eax
		;;;;;;;;;;;;;;;;;;;;;;		   
		   ;;; Readconsole()  ||  getch()  -- need help. 

		%elif currchar='['

		    %push BFWHILE
		    %$w:
		    cmp   byte[eax],0
		    
		    je    near %$x
		    

		%elif currchar=']'
		   %ifctx BFWHILE
			   jmp     %$w
		   %$x:
			   %pop
		   %else
			   %fatal "Expected '[' before ']'"
		   %endif

		%endif

		%assign i i+1
	%endrep
	%ifdef NAGOA
		%define call call_    
	%endif
%endmacro
